!MNH_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
!------------------------------------------------------------------------------
!    #######################
     MODULE MODI_IBM_AFFECTP_MOY  
!    ####################### 
!
INTERFACE
!
SUBROUTINE IBM_AFFECTP_MOY(KTCOUNT,KTCOUNT_MIN,KTCOUNT_STEP)
!
INTEGER                          ,INTENT(IN)    :: KTCOUNT,KTCOUNT_MIN,KTCOUNT_STEP
!
!------------------------------------------------------------------------------
!
END SUBROUTINE IBM_AFFECTP_MOY
!
END INTERFACE
!
END MODULE MODI_IBM_AFFECTP_MOY
!
!     ########################################################
      SUBROUTINE IBM_AFFECTP_MOY(KTCOUNT,KTCOUNT_MIN,KTCOUNT_STEP)
!     ########################################################
!
!!

!!    --------
!!      SUBROUTINE ?
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!       MODD_?   
!!
!!    REFERENCE
!!    ---------
!!
!!    AUTHOR
!!    ------
!!      Franck Auguste (CERFACS-AE)
!!
!!    MODIFICATIONS
!!    -------------
!!      Original         01/01/2018
!!
!------------------------------------------------------------------------------
!       
!**** 0. DECLARATIONS
!     ---------------
! module
USE MODE_POS
USE MODE_ll
USE MODE_IO_ll
!
! declaration
USE MODD_IBM_PARAM_n
!
! interface
USE MODD_REF_n,           ONLY: XRHODJ,XRHODREF
USE MODD_CST
USE MODD_RADIATIONS_n
USE MODD_DYN_n
USE MODD_FIELD_n
USE MODI_IBM_SOLAR_SHADOW
USE MODD_GRID_n,          ONLY: XXHAT,XYHAT
!
IMPLICIT NONE
!
!------------------------------------------------------------------------------
!
!       0.1  declarations of arguments
!
INTEGER                          ,INTENT(IN)    :: KTCOUNT,KTCOUNT_MIN,KTCOUNT_STEP                             ! integration period
!
!------------------------------------------------------------------------------
!
!       0.2  declaration of local variables
!
INTEGER                                  :: JI,JJ,JK,JM,JN,JMM,I_GHOST_NUMB                                               ! loop index
INTEGER                                  :: JI1,JJ1,JK1,JI2,JJ2,JK2,JI3,JJ3,JK3
!
!------------------------------------------------------------------------------
!
!       0.3  Allocation
!
!------------------------------------------------------------------------------
!
!**** 1. PRELIMINARIES
!     ----------------
!
!**** 2. EXECUTIONS
!     -------------

  DO JMM=1,1
    !
    ! searching number of ghosts 
    JM = size(NIBM_GHOST_P,1)
    JI = 0!NIBM_GHOST_P(JM,JMM,1,1)
    JJ = 0!NIBM_GHOST_P(JM,JMM,1,2)
    JK = 0!NIBM_GHOST_P(JM,JMM,1,3)
    DO WHILE ((JI==0.and.JJ==0.and.JK==0).and.JM>0)
      JI = NIBM_GHOST_P(JM,JMM,1,1)
      JJ = NIBM_GHOST_P(JM,JMM,1,2)
      JK = NIBM_GHOST_P(JM,JMM,1,3)
      IF (JI==0.and.JJ==0.and.JK==0) JM = JM - 1
    ENDDO
    I_GHOST_NUMB = JM
    !
    ! Loop on each P Ghosts 
    IF (I_GHOST_NUMB<=0) GO TO 666
    DO JM = 1,I_GHOST_NUMB
      !
      ! ghost index/ls
      JI = NIBM_GHOST_P(JM,JMM,1,1)
      JJ = NIBM_GHOST_P(JM,JMM,1,2)
      JK = NIBM_GHOST_P(JM,JMM,1,3)
      IF (JI==0.or.JJ==0.or.JK==0) GO TO 777

      DO JN=1,8
        XIBM_MOY_P(JM,JMM,JN) = 1./(KTCOUNT*1.-KTCOUNT_MIN+1.)*((KTCOUNT*1.-KTCOUNT_MIN*1.)*XIBM_MOY_P(JM,JMM,JN)+XIBM_SOLAR_P(JM,JMM,JN))
      ENDDO

777   CONTINUE

    ENDDO

  ENDDO

666   CONTINUE


!
!
!**** X. DEALLOCATIONS/CLOSES
!     -----------------------
!
RETURN
!
END SUBROUTINE IBM_AFFECTP_MOY
