!  Special set of characters for RCS information
! $Source: /home/cvsroot/MNH-VX-Y-Z/src/MNH/modn_ibm_param.f90,v $ 
!------------------------------------------------------------------------------
!     #######################  
      MODULE MODN_EMIS_PARAM_n
!     #######################
!
!!****  *MODN_EMIS_PARAM$n* - declaration of namelist NAM_EMIS_PARAMn
!!
!!    PURPOSE
!!    -------
!!****  The purpose of this declarative module is to declare the constants
!!      which allow to initialize the embedded surface 
!!
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!      Module MODD_EMIS_PARAM$n : contains declaration of EMIS parameters 
!!
!!
!!    REFERENCE
!!    ---------
!!          
!!    AUTHOR
!!    ------
!!	Franck Auguste (CERFACS-AE)
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/01/2015
!
USE MODD_EMIS_PARAM_n, ONLY: &
         LEMIS_n => LEMIS, &                
         NEMIS_FILE_n => NEMIS_FILE, &
         XEMIS_RESI_n => XEMIS_RESI, &
         NEMIS_HOUR_n => NEMIS_HOUR
!
IMPLICIT NONE
!
LOGICAL,SAVE  :: LEMIS
REAL,SAVE  :: XEMIS_RESI
INTEGER,SAVE :: NEMIS_FILE
INTEGER,SAVE :: NEMIS_HOUR
!
NAMELIST /NAM_EMIS_PARAMn/ LEMIS, NEMIS_FILE, XEMIS_RESI, NEMIS_HOUR
!
CONTAINS
!
SUBROUTINE INIT_NAM_EMIS_PARAMn
LEMIS      = LEMIS_n
NEMIS_FILE = NEMIS_FILE_n
NEMIS_HOUR = NEMIS_HOUR_n
XEMIS_RESI = XEMIS_RESI_n
END SUBROUTINE INIT_NAM_EMIS_PARAMn

SUBROUTINE UPDATE_NAM_EMIS_PARAMn
LEMIS_n      = LEMIS
NEMIS_FILE_n = NEMIS_FILE
NEMIS_HOUR_n = NEMIS_HOUR
XEMIS_RESI_n = XEMIS_RESI
END SUBROUTINE UPDATE_NAM_EMIS_PARAMn
!
!------------------------------------------------------------------------------
!
END MODULE MODN_EMIS_PARAM_n
!
