!  Special set of characters for RCS information
! $Source: /home/cvsroot/MNH-VX-Y-Z/src/MNH/modn_ibm_param.f90,v $ 
!------------------------------------------------------------------------------
!     #######################  
      MODULE MODN_IBM_PARAM_n
!     #######################
!
!!****  *MODN_IBM_PARAM$n* - declaration of namelist NAM_IBM_PARAMn
!!
!!    PURPOSE
!!    -------
!!****  The purpose of this declarative module is to declare the constants
!!      which allow to initialize the embedded surface 
!!
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!      Module MODD_IBM_PARAM$n : contains declaration of IBM parameters 
!!
!!
!!    REFERENCE
!!    ---------
!!          
!!    AUTHOR
!!    ------
!!	Franck Auguste (CERFACS-AE)
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/01/2015
!
USE MODD_IBM_PARAM_n, ONLY: &
         LIBM_n => LIBM, &
         LIBM_SOLAR_n => LIBM_SOLAR, &
         LIBM_RLS_n => LIBM_RLS, &
         LRECYCL_n => LRECYCL, &
         CIBM_TYPE_n => CIBM_TYPE, &
         XIBM_EPSI_n => XIBM_EPSI, &
         XIBM_IEPS_n => XIBM_IEPS, &
         XIBM_RES_n => XIBM_RES, &
         XIBM_RES2_n => XIBM_RES2, &
         XIBM_SFTH_n => XIBM_SFTH, &
         XIBM_DIV_n => XIBM_DIV, &
         NIBM_ITR_n => NIBM_ITR, &
         XIBM_CFL_n => XIBM_CFL, &

         NIBM_SMOOTH_n => NIBM_SMOOTH, &
         XIBM_SMOOTH_n => XIBM_SMOOTH, &
         XIBM_VIT_n => XIBM_VIT, &
         XXRECYCLB1_n => XXRECYCLB1, &
         XYRECYCLB1_n => XYRECYCLB1, &
         XXRECYCLE1_n => XXRECYCLE1, &
         XYRECYCLE1_n => XYRECYCLE1, &
         XXRECYCLB2_n => XXRECYCLB2, &
         XYRECYCLB2_n => XYRECYCLB2, &
         XXRECYCLE2_n => XXRECYCLE2, &
         XYRECYCLE2_n => XYRECYCLE2, &
         XDRECYCL_n => XDRECYCL , &
         XARECYCL_n => XARECYCL , &
         XIBM_RUG_n => XIBM_RUG, &
         XIBM_LATORI_n => XIBM_LATORI, &
         XIBM_LONORI_n => XIBM_LONORI, &
         XIBM_IDEA_DELT_n => XIBM_IDEA_DELT, &
         XIBM_TKE_n => XIBM_TKE, &
         XIBM_VISC_U_n => XIBM_VISC_U, &
         XIBM_VISC_T_n => XIBM_VISC_T, &
         XIBM_VISC_E_n => XIBM_VISC_E, &
         XIBM_VISC_R_n => XIBM_VISC_R, &
         XIBM_VISC_S_n => XIBM_VISC_S, &
         XIBM_2DIFU_n => XIBM_2DIFU, &

         XIBM_SOLAR_ANX_n => XIBM_SOLAR_ANX, &
         XIBM_SOLAR_ANY_n => XIBM_SOLAR_ANY, &
         XIBM_SOLAR_ANZ_n => XIBM_SOLAR_ANZ, &
         XIBM_SOLAR_MAX_n => XIBM_SOLAR_MAX, &
         XIBM_SOLAR_ERR_n => XIBM_SOLAR_ERR, &
         XIBM_SOLAR_EXP_n => XIBM_SOLAR_EXP, &
         XIBM_SOLAR_REF_n => XIBM_SOLAR_REF, &
         XIBM_SOLAR_CPG_n => XIBM_SOLAR_CPG, &
         XIBM_SOLAR_DZG_n => XIBM_SOLAR_DZG, &
         XIBM_SOLAR_DZR_n => XIBM_SOLAR_DZR, &
         XIBM_SOLAR_LBG_n => XIBM_SOLAR_LBG, &
         XIBM_SOLAR_LBF_n => XIBM_SOLAR_LBF, &
         XIBM_SOLAR_EMI_n => XIBM_SOLAR_EMI, &

              NIBM_LAYER_P_n =>      NIBM_LAYER_P ,&
             XIBM_RADIUS_P_n =>     XIBM_RADIUS_P ,&
             XIBM_POWERS_P_n =>     XIBM_POWERS_P ,&
         CIBM_MODE_INTE1_P_n => CIBM_MODE_INTE1_P ,&
         CIBM_MODE_INTE3_P_n => CIBM_MODE_INTE3_P ,&
         CIBM_MODE_BOUND_P_n => CIBM_MODE_BOUND_P ,&
         CIBM_TYPE_BOUND_P_n => CIBM_TYPE_BOUND_P ,&
         CIBM_FORC_BOUND_P_n => CIBM_FORC_BOUND_P ,&
         XIBM_FORC_BOUND_P_n => XIBM_FORC_BOUND_P ,&

              NIBM_LAYER_Q_n =>      NIBM_LAYER_Q ,&
             XIBM_RADIUS_Q_n =>     XIBM_RADIUS_Q ,&
             XIBM_POWERS_Q_n =>     XIBM_POWERS_Q ,&
         CIBM_MODE_INTE1_Q_n => CIBM_MODE_INTE1_Q ,&
         CIBM_MODE_INTE3_Q_n => CIBM_MODE_INTE3_Q ,&
         CIBM_MODE_BOUND_Q_n => CIBM_MODE_BOUND_Q ,&
         CIBM_TYPE_BOUND_Q_n => CIBM_TYPE_BOUND_Q ,&
         CIBM_FORC_BOUND_Q_n => CIBM_FORC_BOUND_Q ,&
         XIBM_FORC_BOUND_Q_n => XIBM_FORC_BOUND_Q ,&

              NIBM_LAYER_R_n =>      NIBM_LAYER_R ,&
             XIBM_RADIUS_R_n =>     XIBM_RADIUS_R ,&
             XIBM_POWERS_R_n =>     XIBM_POWERS_R ,&
         CIBM_MODE_INTE1_R_n => CIBM_MODE_INTE1_R ,&
         CIBM_MODE_INTE3_R_n => CIBM_MODE_INTE3_R ,&
         CIBM_MODE_BOUND_R_n => CIBM_MODE_BOUND_R ,&
         CIBM_TYPE_BOUND_R_n => CIBM_TYPE_BOUND_R ,&
         CIBM_FORC_BOUND_R_n => CIBM_FORC_BOUND_R ,&
         XIBM_FORC_BOUND_R_n => XIBM_FORC_BOUND_R ,&

              NIBM_LAYER_S_n =>      NIBM_LAYER_S ,&
             XIBM_RADIUS_S_n =>     XIBM_RADIUS_S ,&
             XIBM_POWERS_S_n =>     XIBM_POWERS_S ,&
         CIBM_MODE_INTE1_S_n => CIBM_MODE_INTE1_S ,&
         CIBM_MODE_INTE3_S_n => CIBM_MODE_INTE3_S ,&
         CIBM_MODE_BOUND_S_n => CIBM_MODE_BOUND_S ,&
         CIBM_TYPE_BOUND_S_n => CIBM_TYPE_BOUND_S ,&
         CIBM_FORC_BOUND_S_n => CIBM_FORC_BOUND_S ,&
         XIBM_FORC_BOUND_S_n => XIBM_FORC_BOUND_S ,&

              NIBM_LAYER_T_n =>      NIBM_LAYER_T ,&
             XIBM_RADIUS_T_n =>     XIBM_RADIUS_T ,&
             XIBM_POWERS_T_n =>     XIBM_POWERS_T ,&
         CIBM_MODE_INTE1_T_n => CIBM_MODE_INTE1_T ,&
         CIBM_MODE_INTE3_T_n => CIBM_MODE_INTE3_T ,&
         CIBM_MODE_BOUND_T_n => CIBM_MODE_BOUND_T ,&
         CIBM_TYPE_BOUND_T_n => CIBM_TYPE_BOUND_T ,&
         CIBM_FORC_BOUND_T_n => CIBM_FORC_BOUND_T ,&
         XIBM_FORC_BOUND_T_n => XIBM_FORC_BOUND_T ,&

              NIBM_LAYER_E_n =>      NIBM_LAYER_E ,&
             XIBM_RADIUS_E_n =>     XIBM_RADIUS_E ,&
             XIBM_POWERS_E_n =>     XIBM_POWERS_E ,&
         CIBM_MODE_INTE1_E_n => CIBM_MODE_INTE1_E ,&
         CIBM_MODE_INTE3_E_n => CIBM_MODE_INTE3_E ,&
         CIBM_MODE_BOUND_E_n => CIBM_MODE_BOUND_E ,&
         CIBM_TYPE_BOUND_E_n => CIBM_TYPE_BOUND_E ,&
         CIBM_FORC_BOUND_E_n => CIBM_FORC_BOUND_E ,&
         XIBM_FORC_BOUND_E_n => XIBM_FORC_BOUND_E ,&

         NIBM_LAYER_V_n      =>      NIBM_LAYER_V ,&
         XIBM_RADIUS_V_n     =>     XIBM_RADIUS_V ,&
         XIBM_POWERS_V_n     =>     XIBM_POWERS_V ,&
         CIBM_MODE_INTE1NV_n => CIBM_MODE_INTE1NV ,&
         CIBM_MODE_INTE1TV_n => CIBM_MODE_INTE1TV ,&
         CIBM_MODE_INTE1CV_n => CIBM_MODE_INTE1CV ,&
         CIBM_MODE_INTE3_V_n => CIBM_MODE_INTE3_V ,&
         CIBM_MODE_BOUNN_V_n => CIBM_MODE_BOUNN_V ,&
         CIBM_TYPE_BOUNN_V_n => CIBM_TYPE_BOUNN_V ,&
         CIBM_MODE_BOUNT_V_n => CIBM_MODE_BOUNT_V ,&
         CIBM_TYPE_BOUNT_V_n => CIBM_TYPE_BOUNT_V ,&
         CIBM_MODE_BOUNC_V_n => CIBM_MODE_BOUNC_V ,&
         CIBM_TYPE_BOUNC_V_n => CIBM_TYPE_BOUNC_V ,&
         CIBM_FORC_BOUNN_V_n => CIBM_FORC_BOUNN_V ,&
         CIBM_FORC_BOUNR_V_n => CIBM_FORC_BOUNR_V ,&
         CIBM_FORC_BOUNT_V_n => CIBM_FORC_BOUNT_V ,&
         CIBM_FORC_BOUNC_V_n => CIBM_FORC_BOUNC_V ,&                                            
         XIBM_FORC_BOUNN_V_n => XIBM_FORC_BOUNN_V ,&
         XIBM_FORC_BOUNT_V_n => XIBM_FORC_BOUNT_V ,&
         XIBM_FORC_BOUNC_V_n => XIBM_FORC_BOUNC_V
!
IMPLICIT NONE
!
LOGICAL,SAVE  :: LIBM,LIBM_RLS,LRECYCL,LIBM_SOLAR
CHARACTER (LEN=5),SAVE  :: CIBM_TYPE
REAL,SAVE  :: XIBM_EPSI
REAL,SAVE  :: XIBM_IEPS
REAL,SAVE  :: XIBM_RES,XIBM_DIV,XIBM_CFL,XIBM_RES2,XIBM_SFTH
INTEGER,SAVE :: NIBM_ITR
INTEGER,SAVE :: NIBM_SMOOTH
REAL,SAVE  :: XIBM_SMOOTH
REAL,SAVE  :: XIBM_VIT
REAL,SAVE  :: XXRECYCLB1,XXRECYCLE1,XYRECYCLB1,XYRECYCLE1,XXRECYCLB2,XXRECYCLE2,XYRECYCLB2,XYRECYCLE2,XDRECYCL,XARECYCL
REAL,SAVE  :: XIBM_RUG,XIBM_LATORI,XIBM_LONORI
REAL,SAVE  :: XIBM_SOLAR_ANX,XIBM_SOLAR_ANY,XIBM_SOLAR_ANZ,XIBM_SOLAR_MAX,XIBM_SOLAR_EXP,XIBM_SOLAR_ERR,XIBM_SOLAR_REF 
REAL,SAVE  :: XIBM_SOLAR_CPG,XIBM_SOLAR_DZG,XIBM_SOLAR_DZR,XIBM_SOLAR_LBG,XIBM_SOLAR_LBF,XIBM_SOLAR_EMI
REAL,SAVE  :: XIBM_VISC_U,XIBM_VISC_T,XIBM_VISC_E,XIBM_VISC_R,XIBM_VISC_S,XIBM_TKE,XIBM_2DIFU
REAL,SAVE  :: XIBM_IDEA_DELT
INTEGER,SAVE :: NIBM_LAYER_P,NIBM_LAYER_Q,NIBM_LAYER_R,NIBM_LAYER_S,NIBM_LAYER_T,NIBM_LAYER_E,NIBM_LAYER_V
CHARACTER (LEN=3),SAVE :: CIBM_MODE_INTE1_P,CIBM_MODE_INTE1_Q,CIBM_MODE_INTE1_R,CIBM_MODE_INTE1_S,&
                          CIBM_MODE_INTE1_T,CIBM_MODE_INTE1_E,&
                          CIBM_MODE_INTE1NV,CIBM_MODE_INTE1TV,CIBM_MODE_INTE1CV,&
                          CIBM_MODE_INTE3_P,CIBM_MODE_INTE3_Q,CIBM_MODE_INTE3_R,CIBM_MODE_INTE3_S,&
                          CIBM_MODE_INTE3_T,CIBM_MODE_INTE3_E,CIBM_MODE_INTE3_V
CHARACTER (LEN=3),SAVE :: CIBM_MODE_BOUND_P,CIBM_MODE_BOUND_Q,CIBM_MODE_BOUND_R,CIBM_MODE_BOUND_S,&
                          CIBM_MODE_BOUND_T,CIBM_MODE_BOUND_E,&
                          CIBM_TYPE_BOUND_P,CIBM_TYPE_BOUND_Q,CIBM_TYPE_BOUND_R,CIBM_TYPE_BOUND_S,&
                          CIBM_TYPE_BOUND_T,CIBM_TYPE_BOUND_E,&
                          CIBM_FORC_BOUND_P,CIBM_FORC_BOUND_Q,CIBM_FORC_BOUND_R,CIBM_FORC_BOUND_S,&
                          CIBM_FORC_BOUND_T,CIBM_FORC_BOUND_E,&
                          CIBM_MODE_BOUNN_V,CIBM_MODE_BOUNT_V,CIBM_MODE_BOUNC_V,&
                          CIBM_TYPE_BOUNN_V,CIBM_TYPE_BOUNT_V,CIBM_TYPE_BOUNC_V,&
                          CIBM_FORC_BOUNN_V,CIBM_FORC_BOUNT_V,CIBM_FORC_BOUNC_V,CIBM_FORC_BOUNR_V
REAL,SAVE  :: XIBM_FORC_BOUNN_V,XIBM_FORC_BOUNT_V,XIBM_FORC_BOUNC_V,&
              XIBM_FORC_BOUND_P,XIBM_FORC_BOUND_Q,XIBM_FORC_BOUND_R,XIBM_FORC_BOUND_S,&
              XIBM_FORC_BOUND_T,XIBM_FORC_BOUND_E
REAL,SAVE  :: XIBM_RADIUS_P,XIBM_RADIUS_Q,XIBM_RADIUS_R,XIBM_RADIUS_S,&
                          XIBM_RADIUS_T,XIBM_RADIUS_E,XIBM_RADIUS_V,&
                          XIBM_POWERS_P,XIBM_POWERS_Q,XIBM_POWERS_R,XIBM_POWERS_S,&
                          XIBM_POWERS_T,XIBM_POWERS_E,XIBM_POWERS_V
!
NAMELIST /NAM_IBM_PARAMn/ LIBM, LIBM_SOLAR, LIBM_RLS,LRECYCL ,CIBM_TYPE,     &
                          XIBM_VISC_U, XIBM_VISC_E, XIBM_VISC_T, XIBM_VISC_R, XIBM_VISC_S,XIBM_2DIFU,XIBM_TKE, &
                          XIBM_EPSI, XIBM_IEPS, XIBM_RES,XIBM_RES2,XIBM_DIV,NIBM_ITR,XIBM_CFL,XIBM_SFTH, &
                          NIBM_SMOOTH, XIBM_SMOOTH,XIBM_VIT,XIBM_RUG, &
                          XXRECYCLB1,XXRECYCLE1,XYRECYCLB1,XYRECYCLE1,&
                          XXRECYCLB2,XXRECYCLE2,XYRECYCLB2,XYRECYCLE2,XDRECYCL,XARECYCL,&
                          XIBM_IDEA_DELT, XIBM_LATORI,XIBM_LONORI, &
                          XIBM_SOLAR_ANX,XIBM_SOLAR_ANY,XIBM_SOLAR_ANZ,XIBM_SOLAR_MAX,XIBM_SOLAR_EXP,XIBM_SOLAR_ERR,XIBM_SOLAR_REF, &
                          XIBM_SOLAR_CPG,XIBM_SOLAR_DZG,XIBM_SOLAR_DZR,XIBM_SOLAR_LBG,XIBM_SOLAR_LBF,XIBM_SOLAR_EMI,&
                          NIBM_LAYER_P,NIBM_LAYER_Q,NIBM_LAYER_R,NIBM_LAYER_S,&
                          NIBM_LAYER_T,NIBM_LAYER_E,NIBM_LAYER_V,&
                          CIBM_MODE_INTE1_P,CIBM_MODE_INTE1_Q,CIBM_MODE_INTE1_R,CIBM_MODE_INTE1_S,&
                          CIBM_MODE_INTE1_T,CIBM_MODE_INTE1_E,&
                          CIBM_MODE_INTE1NV,CIBM_MODE_INTE1TV,CIBM_MODE_INTE1CV,&
                          CIBM_MODE_INTE3_P,CIBM_MODE_INTE3_Q,CIBM_MODE_INTE3_R,CIBM_MODE_INTE3_S,&
                          CIBM_MODE_INTE3_T,CIBM_MODE_INTE3_E,CIBM_MODE_INTE3_V,&
                          CIBM_MODE_BOUND_P,CIBM_MODE_BOUND_Q,CIBM_MODE_BOUND_R,CIBM_MODE_BOUND_S,&
                          CIBM_MODE_BOUND_T,CIBM_MODE_BOUND_E,&
                          CIBM_TYPE_BOUND_P,CIBM_TYPE_BOUND_Q,CIBM_TYPE_BOUND_R,CIBM_TYPE_BOUND_S,&
                          CIBM_TYPE_BOUND_T,CIBM_TYPE_BOUND_E,&                    
                          CIBM_FORC_BOUND_P,CIBM_FORC_BOUND_Q,CIBM_FORC_BOUND_R,CIBM_FORC_BOUND_S,&
                          CIBM_FORC_BOUND_T,CIBM_FORC_BOUND_E,&
                          XIBM_FORC_BOUND_P,XIBM_FORC_BOUND_Q,XIBM_FORC_BOUND_R,XIBM_FORC_BOUND_S,&
                          XIBM_FORC_BOUND_T,XIBM_FORC_BOUND_E,&
                          CIBM_MODE_BOUNN_V,CIBM_MODE_BOUNT_V,CIBM_MODE_BOUNC_V,&
                          CIBM_TYPE_BOUNN_V,CIBM_TYPE_BOUNT_V,CIBM_TYPE_BOUNC_V,&
                          CIBM_FORC_BOUNN_V,CIBM_FORC_BOUNT_V,CIBM_FORC_BOUNC_V,CIBM_FORC_BOUNR_V,&
                          XIBM_FORC_BOUNN_V,XIBM_FORC_BOUNT_V,XIBM_FORC_BOUNC_V,&
                          XIBM_RADIUS_P,XIBM_RADIUS_Q,XIBM_RADIUS_R,XIBM_RADIUS_S,&
                          XIBM_RADIUS_T,XIBM_RADIUS_E,XIBM_RADIUS_V,&
                          XIBM_POWERS_P,XIBM_POWERS_Q,XIBM_POWERS_R,XIBM_POWERS_S,&
                          XIBM_POWERS_T,XIBM_POWERS_E,XIBM_POWERS_V
!
CONTAINS
!
SUBROUTINE INIT_NAM_IBM_PARAMn
  LIBM = LIBM_n
  LIBM_SOLAR = LIBM_SOLAR_n
  LIBM_RLS = LIBM_RLS_n
  LRECYCL = LRECYCL_n
  CIBM_TYPE = CIBM_TYPE_n
  XIBM_EPSI = XIBM_EPSI_n
  XIBM_IEPS = XIBM_IEPS_n
  XIBM_RES = XIBM_RES_n
  XIBM_RES2= XIBM_RES2_n
  XIBM_SFTH= XIBM_SFTH_n
  XIBM_CFL = XIBM_CFL_n
  XIBM_DIV = XIBM_DIV_n
  NIBM_ITR = NIBM_ITR_n
  NIBM_SMOOTH = NIBM_SMOOTH_n
  XIBM_SMOOTH = XIBM_SMOOTH_n
  XIBM_VIT = XIBM_VIT_n
  XXRECYCLB1 = XXRECYCLB1_n
  XYRECYCLB1 = XYRECYCLB1_n
  XXRECYCLE1 = XXRECYCLE1_n
  XYRECYCLE1 = XYRECYCLE1_n
  XXRECYCLB2 = XXRECYCLB2_n
  XYRECYCLB2 = XYRECYCLB2_n
  XXRECYCLE2 = XXRECYCLE2_n
  XYRECYCLE2 = XYRECYCLE2_n
  XDRECYCL = XDRECYCL_n 
  XARECYCL = XARECYCL_n 
  XIBM_RUG = XIBM_RUG_n
  XIBM_LATORI = XIBM_LATORI_n
  XIBM_LONORI = XIBM_LONORI_n
  XIBM_TKE    = XIBM_TKE_n
  XIBM_VISC_U = XIBM_VISC_U_n
  XIBM_VISC_T = XIBM_VISC_T_n
  XIBM_VISC_E = XIBM_VISC_E_n
  XIBM_VISC_R = XIBM_VISC_R_n
  XIBM_VISC_S = XIBM_VISC_S_n
  XIBM_2DIFU = XIBM_2DIFU_n

  XIBM_SOLAR_ANX = XIBM_SOLAR_ANX_n
  XIBM_SOLAR_ANY = XIBM_SOLAR_ANY_n
  XIBM_SOLAR_ANZ = XIBM_SOLAR_ANZ_n
  XIBM_SOLAR_MAX = XIBM_SOLAR_MAX_n
  XIBM_SOLAR_ERR = XIBM_SOLAR_ERR_n
  XIBM_SOLAR_EXP = XIBM_SOLAR_EXP_n
  XIBM_SOLAR_REF = XIBM_SOLAR_REF_n
  XIBM_SOLAR_CPG = XIBM_SOLAR_CPG_n
  XIBM_SOLAR_DZG = XIBM_SOLAR_DZG_n
  XIBM_SOLAR_DZR = XIBM_SOLAR_DZR_n
  XIBM_SOLAR_LBG = XIBM_SOLAR_LBG_n
  XIBM_SOLAR_LBF = XIBM_SOLAR_LBF_n
  XIBM_SOLAR_EMI = XIBM_SOLAR_EMI_n

  XIBM_IDEA_DELT = XIBM_IDEA_DELT_n

              NIBM_LAYER_P =      NIBM_LAYER_P_n 
             XIBM_RADIUS_P =     XIBM_RADIUS_P_n 
             XIBM_POWERS_P =     XIBM_POWERS_P_n 
         CIBM_MODE_INTE1_P = CIBM_MODE_INTE1_P_n 
         CIBM_MODE_INTE3_P = CIBM_MODE_INTE3_P_n 
         CIBM_MODE_BOUND_P = CIBM_MODE_BOUND_P_n 
         CIBM_TYPE_BOUND_P = CIBM_TYPE_BOUND_P_n 
         CIBM_FORC_BOUND_P = CIBM_FORC_BOUND_P_n
         XIBM_FORC_BOUND_P = XIBM_FORC_BOUND_P_n

              NIBM_LAYER_Q =      NIBM_LAYER_Q_n 
             XIBM_RADIUS_Q =     XIBM_RADIUS_Q_n 
             XIBM_POWERS_Q =     XIBM_POWERS_Q_n 
         CIBM_MODE_INTE1_Q = CIBM_MODE_INTE1_Q_n 
         CIBM_MODE_INTE3_Q = CIBM_MODE_INTE3_Q_n 
         CIBM_MODE_BOUND_Q = CIBM_MODE_BOUND_Q_n 
         CIBM_TYPE_BOUND_Q = CIBM_TYPE_BOUND_Q_n
         CIBM_FORC_BOUND_Q = CIBM_FORC_BOUND_Q_n 
         XIBM_FORC_BOUND_Q = XIBM_FORC_BOUND_Q_n

              NIBM_LAYER_R =      NIBM_LAYER_R_n 
             XIBM_RADIUS_R =     XIBM_RADIUS_R_n 
             XIBM_POWERS_R =     XIBM_POWERS_R_n 
         CIBM_MODE_INTE1_R = CIBM_MODE_INTE1_R_n 
         CIBM_MODE_INTE3_R = CIBM_MODE_INTE3_R_n 
         CIBM_MODE_BOUND_R = CIBM_MODE_BOUND_R_n 
         CIBM_TYPE_BOUND_R = CIBM_TYPE_BOUND_R_n 
         CIBM_FORC_BOUND_R = CIBM_FORC_BOUND_R_n
         XIBM_FORC_BOUND_R = XIBM_FORC_BOUND_R_n

              NIBM_LAYER_S =      NIBM_LAYER_S_n 
             XIBM_RADIUS_S =     XIBM_RADIUS_S_n 
             XIBM_POWERS_S =     XIBM_POWERS_S_n 
         CIBM_MODE_INTE1_S = CIBM_MODE_INTE1_S_n 
         CIBM_MODE_INTE3_S = CIBM_MODE_INTE3_S_n
         CIBM_MODE_BOUND_S = CIBM_MODE_BOUND_S_n 
         CIBM_TYPE_BOUND_S = CIBM_TYPE_BOUND_S_n
         CIBM_FORC_BOUND_S = CIBM_FORC_BOUND_S_n
         XIBM_FORC_BOUND_S = XIBM_FORC_BOUND_S_n

              NIBM_LAYER_T =      NIBM_LAYER_T_n
             XIBM_RADIUS_T =     XIBM_RADIUS_T_n
             XIBM_POWERS_T =     XIBM_POWERS_T_n
         CIBM_MODE_INTE1_T = CIBM_MODE_INTE1_T_n
         CIBM_MODE_INTE3_T = CIBM_MODE_INTE3_T_n
         CIBM_MODE_BOUND_T = CIBM_MODE_BOUND_T_n
         CIBM_TYPE_BOUND_T = CIBM_TYPE_BOUND_T_n
         CIBM_FORC_BOUND_T = CIBM_FORC_BOUND_T_n
         XIBM_FORC_BOUND_T = XIBM_FORC_BOUND_T_n

              NIBM_LAYER_E =      NIBM_LAYER_E_n
             XIBM_RADIUS_E =     XIBM_RADIUS_E_n
             XIBM_POWERS_E =     XIBM_POWERS_E_n
         CIBM_MODE_INTE1_E = CIBM_MODE_INTE1_E_n
         CIBM_MODE_INTE3_E = CIBM_MODE_INTE3_E_n
         CIBM_MODE_BOUND_E = CIBM_MODE_BOUND_E_n
         CIBM_TYPE_BOUND_E = CIBM_TYPE_BOUND_E_n
         CIBM_FORC_BOUND_E = CIBM_FORC_BOUND_E_n
         XIBM_FORC_BOUND_E = XIBM_FORC_BOUND_E_n

         NIBM_LAYER_V      =      NIBM_LAYER_V_n
         XIBM_RADIUS_V     =     XIBM_RADIUS_V_n
         XIBM_POWERS_V     =     XIBM_POWERS_V_n
         CIBM_MODE_INTE1NV = CIBM_MODE_INTE1NV_n
         CIBM_MODE_INTE1TV = CIBM_MODE_INTE1TV_n
         CIBM_MODE_INTE1CV = CIBM_MODE_INTE1CV_n
         CIBM_MODE_INTE3_V = CIBM_MODE_INTE3_V_n
         CIBM_MODE_BOUNN_V = CIBM_MODE_BOUNN_V_n
         CIBM_TYPE_BOUNN_V = CIBM_TYPE_BOUNN_V_n
         CIBM_MODE_BOUNT_V = CIBM_MODE_BOUNT_V_n
         CIBM_TYPE_BOUNT_V = CIBM_TYPE_BOUNT_V_n
         CIBM_MODE_BOUNC_V = CIBM_MODE_BOUNC_V_n
         CIBM_TYPE_BOUNC_V = CIBM_TYPE_BOUNC_V_n
         CIBM_FORC_BOUNN_V = CIBM_FORC_BOUNN_V_n
         CIBM_FORC_BOUNR_V = CIBM_FORC_BOUNR_V_n
         CIBM_FORC_BOUNT_V = CIBM_FORC_BOUNT_V_n
         CIBM_FORC_BOUNC_v = CIBM_FORC_BOUNC_V_n
         XIBM_FORC_BOUNN_V = XIBM_FORC_BOUNN_V_n
         XIBM_FORC_BOUNT_V = XIBM_FORC_BOUNT_V_n
         XIBM_FORC_BOUNC_v = XIBM_FORC_BOUNC_V_n

END SUBROUTINE INIT_NAM_IBM_PARAMn

SUBROUTINE UPDATE_NAM_IBM_PARAMn
  LIBM_n = LIBM
  LIBM_SOLAR_n = LIBM_SOLAR
  LIBM_RLS_n = LIBM_RLS
  LRECYCL_n = LRECYCL
  CIBM_TYPE_n = CIBM_TYPE
  XIBM_EPSI_n = XIBM_EPSI
  XIBM_IEPS_n = XIBM_IEPS
  XIBM_RES_n = XIBM_RES
  XIBM_RES2_n = XIBM_RES2
  XIBM_SFTH_n = XIBM_SFTH
  XIBM_CFL_n = XIBM_CFL
  XIBM_DIV_n = XIBM_DIV
  NIBM_ITR_n = NIBM_ITR
  NIBM_SMOOTH_n = NIBM_SMOOTH
  XIBM_SMOOTH_n = XIBM_SMOOTH
  XIBM_VIT_n = XIBM_VIT
  XXRECYCLB1_n = XXRECYCLB1
  XYRECYCLB1_n = XYRECYCLB1
  XXRECYCLE1_n = XXRECYCLE1
  XYRECYCLE1_n = XYRECYCLE1
  XXRECYCLB2_n = XXRECYCLB2
  XYRECYCLB2_n = XYRECYCLB2
  XXRECYCLE2_n = XXRECYCLE2
  XYRECYCLE2_n = XYRECYCLE2
  XDRECYCL_n = XDRECYCL 
  XARECYCL_n = XARECYCL 
  XIBM_RUG_n = XIBM_RUG
  XIBM_LATORI_n = XIBM_LATORI
  XIBM_LONORI_n = XIBM_LONORI
  XIBM_TKE_n = XIBM_TKE
  XIBM_VISC_U_n = XIBM_VISC_U
  XIBM_VISC_T_n = XIBM_VISC_T
  XIBM_VISC_E_n = XIBM_VISC_E
  XIBM_VISC_R_n = XIBM_VISC_R
  XIBM_VISC_S_n = XIBM_VISC_S
  XIBM_2DIFU_n = XIBM_2DIFU

  XIBM_SOLAR_ANX_n = XIBM_SOLAR_ANX
  XIBM_SOLAR_ANY_n = XIBM_SOLAR_ANY
  XIBM_SOLAR_ANZ_n = XIBM_SOLAR_ANZ
  XIBM_SOLAR_MAX_n = XIBM_SOLAR_MAX
  XIBM_SOLAR_ERR_n = XIBM_SOLAR_ERR
  XIBM_SOLAR_EXP_n = XIBM_SOLAR_EXP
  XIBM_SOLAR_REF_n = XIBM_SOLAR_REF
  XIBM_SOLAR_CPG_n = XIBM_SOLAR_CPG
  XIBM_SOLAR_DZG_n = XIBM_SOLAR_DZG
  XIBM_SOLAR_DZR_n = XIBM_SOLAR_DZR
  XIBM_SOLAR_LBG_n = XIBM_SOLAR_LBG
  XIBM_SOLAR_LBF_n = XIBM_SOLAR_LBF
  XIBM_SOLAR_EMI_n = XIBM_SOLAR_EMI


  XIBM_IDEA_DELT_n = XIBM_IDEA_DELT

              NIBM_LAYER_P_n =      NIBM_LAYER_P 
             XIBM_RADIUS_P_n =     XIBM_RADIUS_P 
             XIBM_POWERS_P_n =     XIBM_POWERS_P 
         CIBM_MODE_INTE1_P_n = CIBM_MODE_INTE1_P 
         CIBM_MODE_INTE3_P_n = CIBM_MODE_INTE3_P 
         CIBM_MODE_BOUND_P_n = CIBM_MODE_BOUND_P 
         CIBM_TYPE_BOUND_P_n = CIBM_TYPE_BOUND_P
         CIBM_FORC_BOUND_P_n = CIBM_FORC_BOUND_P
         XIBM_FORC_BOUND_P_n = XIBM_FORC_BOUND_P

              NIBM_LAYER_Q_n =      NIBM_LAYER_Q 
             XIBM_RADIUS_Q_n =     XIBM_RADIUS_Q 
             XIBM_POWERS_Q_n =     XIBM_POWERS_Q 
         CIBM_MODE_INTE1_Q_n = CIBM_MODE_INTE1_Q 
         CIBM_MODE_INTE3_Q_n = CIBM_MODE_INTE3_Q 
         CIBM_MODE_BOUND_Q_n = CIBM_MODE_BOUND_Q 
         CIBM_TYPE_BOUND_Q_n = CIBM_TYPE_BOUND_Q 
         CIBM_FORC_BOUND_Q_n = CIBM_FORC_BOUND_Q
         XIBM_FORC_BOUND_Q_n = XIBM_FORC_BOUND_Q

              NIBM_LAYER_R_n =      NIBM_LAYER_R 
             XIBM_RADIUS_R_n =     XIBM_RADIUS_R 
             XIBM_POWERS_R_n =     XIBM_POWERS_R 
         CIBM_MODE_INTE1_R_n = CIBM_MODE_INTE1_R 
         CIBM_MODE_INTE3_R_n = CIBM_MODE_INTE3_R 
         CIBM_MODE_BOUND_R_n = CIBM_MODE_BOUND_R 
         CIBM_TYPE_BOUND_R_n = CIBM_TYPE_BOUND_R
         CIBM_FORC_BOUND_R_n = CIBM_FORC_BOUND_R
         XIBM_FORC_BOUND_R_n = XIBM_FORC_BOUND_R

              NIBM_LAYER_S_n =      NIBM_LAYER_S 
             XIBM_RADIUS_S_n =     XIBM_RADIUS_S 
             XIBM_POWERS_S_n =     XIBM_POWERS_S 
         CIBM_MODE_INTE1_S_n = CIBM_MODE_INTE1_S 
         CIBM_MODE_INTE3_S_n = CIBM_MODE_INTE3_S 
         CIBM_MODE_BOUND_S_n = CIBM_MODE_BOUND_S 
         CIBM_TYPE_BOUND_S_n = CIBM_TYPE_BOUND_S
         CIBM_FORC_BOUND_S_n = CIBM_FORC_BOUND_S
         XIBM_FORC_BOUND_S_n = XIBM_FORC_BOUND_S

              NIBM_LAYER_T_n =      NIBM_LAYER_T 
             XIBM_RADIUS_T_n =     XIBM_RADIUS_T 
             XIBM_POWERS_T_n =     XIBM_POWERS_T 
         CIBM_MODE_INTE1_T_n = CIBM_MODE_INTE1_T 
         CIBM_MODE_INTE3_T_n = CIBM_MODE_INTE3_T 
         CIBM_MODE_BOUND_T_n = CIBM_MODE_BOUND_T 
         CIBM_TYPE_BOUND_T_n = CIBM_TYPE_BOUND_T 
         CIBM_FORC_BOUND_T_n = CIBM_FORC_BOUND_T
         XIBM_FORC_BOUND_T_n = XIBM_FORC_BOUND_T

              NIBM_LAYER_E_n =      NIBM_LAYER_E 
             XIBM_RADIUS_E_n =     XIBM_RADIUS_E 
             XIBM_POWERS_E_n =     XIBM_POWERS_E 
         CIBM_MODE_INTE1_E_n = CIBM_MODE_INTE1_E 
         CIBM_MODE_INTE3_E_n = CIBM_MODE_INTE3_E 
         CIBM_MODE_BOUND_E_n = CIBM_MODE_BOUND_E 
         CIBM_TYPE_BOUND_E_n = CIBM_TYPE_BOUND_E 
         CIBM_FORC_BOUND_E_n = CIBM_FORC_BOUND_E
         XIBM_FORC_BOUND_E_n = XIBM_FORC_BOUND_E

         NIBM_LAYER_V_n      =      NIBM_LAYER_V 
         XIBM_RADIUS_V_n     =     XIBM_RADIUS_V 
         XIBM_POWERS_V_n     =     XIBM_POWERS_V 
         CIBM_MODE_INTE1NV_n = CIBM_MODE_INTE1NV
         CIBM_MODE_INTE1TV_n = CIBM_MODE_INTE1TV
         CIBM_MODE_INTE1CV_n = CIBM_MODE_INTE1CV
         CIBM_MODE_INTE3_V_n = CIBM_MODE_INTE3_V 
         CIBM_MODE_BOUNN_V_n = CIBM_MODE_BOUNN_V 
         CIBM_TYPE_BOUNN_V_n = CIBM_TYPE_BOUNN_V 
         CIBM_MODE_BOUNT_V_n = CIBM_MODE_BOUNT_V 
         CIBM_TYPE_BOUNT_V_n = CIBM_TYPE_BOUNT_V 
         CIBM_MODE_BOUNC_V_n = CIBM_MODE_BOUNC_V 
         CIBM_TYPE_BOUNC_V_n = CIBM_TYPE_BOUNC_V
         XIBM_FORC_BOUNN_V_n = XIBM_FORC_BOUNN_V
         CIBM_FORC_BOUNN_V_n = CIBM_FORC_BOUNN_V
         CIBM_FORC_BOUNR_V_n = CIBM_FORC_BOUNR_V
         XIBM_FORC_BOUNT_V_n = XIBM_FORC_BOUNT_V
         CIBM_FORC_BOUNT_V_n = CIBM_FORC_BOUNT_V
         XIBM_FORC_BOUNC_V_n = XIBM_FORC_BOUNC_V
         CIBM_FORC_BOUNC_V_n = CIBM_FORC_BOUNC_V

END SUBROUTINE UPDATE_NAM_IBM_PARAMn
!------------------------------------------------------------------------------
END MODULE MODN_IBM_PARAM_n
!
